## jami-20250912.0.tar.gz

=== daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(jami-core
    VERSION 16.0.0
    LANGUAGES C CXX)
set(PACKAGE_NAME "Jami Daemon")
set (CMAKE_CXX_STANDARD 17)

set(PROJECT_LABEL "libjami")

################################################################################
# Build options
################################################################################
option(JAMI_NATPMP "Build with NAT-PMP" ON)
option(JAMI_PUPNP "Build with PUPNP" ON)
option(JAMI_PLUGIN "Build with plugin support" ON)
option(JAMI_NODEJS "Build the NODEJS binding" OFF)
option(JAMI_JNI "Build the JNI binding" OFF)
option(JAMI_DBUS "Build the DBUS binding" OFF)
option(JAMI_VIDEO "Build with video support" ON)
option(JAMI_VIDEO_ACCEL "Build video hardware acceleration support" ON)
option(BUILD_CONTRIB "Build contrib to CONTRIB_PATH" ON)
option(BUILD_EXTRA_TOOLS "Build extra tools" OFF)
option(ENABLE_ASAN "Enable address sanitization" OFF)
option(ENABLE_COVERAGE "Enable coverage (for tests)" OFF)

if(ENABLE_ASAN AND NOT MSVC)
  message(STATUS "Address sanitization enabled for daemon")
  # Add AddressSanitizer flags for both compiler and linker
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif()

if(ENABLE_COVERAGE)
    message(STATUS "Coverage analysis enabled for daemon")
    include(CMake/coverage.cmake)
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FILE_OFFSET_BITS=64")

include(CTest)

if(JAMI_NODEJS)
    # Required for nodejs binding
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

if(NOT MSVC)
    ################################################################################
    # Contrib
    ################################################################################

    # Android target mapping for contrib
    if (ANDROID_ABI STREQUAL "x86")
        set(TARGET i686-linux-android)
    elseif (ANDROID_ABI STREQUAL "x86_64")
        set(TARGET x86_64-linux-android)
    elseif (ANDROID_ABI STREQUAL "arm64-v8a")
        set(TARGET aarch64-linux-android)
    elseif (ANDROID_ABI STREQUAL "armeabi-v7a")
        set(TARGET armv7a-linux-androideabi)
    else()
        set(TARGET ${CMAKE_LIBRARY_ARCHITECTURE})
        if (NOT TARGET)
            execute_process(COMMAND gcc -dumpmachine  COMMAND tr -d '\n' OUTPUT_VARIABLE TARGET)
        endif()
    endif()
    set(CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${TARGET})

    include(ProcessorCount)
    ProcessorCount(NPROC)
    if(NOT NPROC EQUAL 0)
        set(CONTRIB_BUILD_FLAGS -j${NPROC})
    endif()

    if (BUILD_EXTRA_TOOLS)
        set(ENV{PATH} "${CMAKE_CURRENT_SOURCE_DIR}/extras/tools/build/bin:$ENV{PATH}")
        execute_process(
            COMMAND ./bootstrap
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make ${CONTRIB_BUILD_FLAGS}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make .pkg-config
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make .gas
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
    endif()
    if (JAMI_JNI)
        # Generate swig binding
        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/jami_wrapper.cpp
            COMMAND env PACKAGEDIR=${JAMI_JNI_PACKAGEDIR} "./make-swig.sh"
            DEPENDS
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/make-swig.sh
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/jni_interface.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/callmanager.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/configurationmanager.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/conversation.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/managerimpl.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/data_view.i
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni
        )
    endif()
endif()

if (BUILD_CONTRIB)
    if (NOT MSVC)
        set(CONTRIB_BUILD_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/native-${TARGET})
        file(MAKE_DIRECTORY ${CONTRIB_BUILD_PATH})
        file(MAKE_DIRECTORY ${CONTRIB_PATH})

        if (ANDROID)
            # See https://developer.android.com/ndk/guides/other_build_systems
            set(ENV{ANDROID_NDK} ${ANDROID_NDK})
            set(ENV{ANDROID_ABI} ${ANDROID_ABI})
            set(ENV{ANDROID_API} ${ANDROID_PLATFORM})
            set(ENV{TOOLCHAIN} ${ANDROID_TOOLCHAIN_ROOT})
            set(ENV{TARGET} ${TARGET})
            set(ENV{API} ${ANDROID_PLATFORM_LEVEL})
            set(ENV{CC} $ENV{TOOLCHAIN}/bin/${TARGET}$ENV{API}-clang)
            set(ENV{CXX} $ENV{TOOLCHAIN}/bin/${TARGET}$ENV{API}-clang++)
            set(ENV{AS} "$ENV{CC} -c")
            set(ENV{AR} ${CMAKE_AR})
            set(ENV{RANLIB} ${CMAKE_RANLIB})
            set(ENV{STRIP} ${CMAKE_STRIP})
            set(ENV{LD} $ENV{TOOLCHAIN}/bin/ld)
        endif()

        file(LOCK ${CONTRIB_BUILD_PATH} DIRECTORY)
        message(STATUS "Building contrib for architectures: ${CMAKE_OSX_ARCHITECTURES} ${CMAKE_SYSTEM}")
        list(LENGTH CMAKE_OSX_ARCHITECTURES CMAKE_OSX_ARCHITECTURES_LENGTH)
        if (APPLE AND CMAKE_OSX_ARCHITECTURES_LENGTH GREATER 1)
            message(STATUS "Building for multiple architectures: ${CMAKE_OSX_ARCHITECTURES}")
            foreach(ARCH ${CMAKE_OSX_ARCHITECTURES})
                message(STATUS "Building for architecture: ${ARCH}")
                set(CC_TARGET ${ARCH}-apple-darwin${CMAKE_SYSTEM_VERSION})
                set(CC_CONTRIB_BUILD_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/native-${CC_TARGET})
                set(CC_CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${CC_TARGET})
                file(MAKE_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
                file(MAKE_DIRECTORY ${CC_CONTRIB_PATH})
                set(BOOTSTRAP_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/contrib/bootstrap --host=${CC_TARGET})
                if (IGNORE_SYSTEM_LIBS)
                    list(APPEND BOOTSTRAP_COMMAND --ignore-system-libs)
                endif()
                execute_process(
                    COMMAND env CMAKE_OSX_ARCHITECTURES=${ARCH} ${BOOTSTRAP_COMMAND}
                    WORKING_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
                execute_process(COMMAND env CMAKE_OSX_ARCHITECTURES=${ARCH} make list
                    WORKING_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
                execute_process(COMMAND env CMAKE_OSX_ARCHITECTURES=${ARCH} make ${CONTRIB_BUILD_FLAGS}
                    WORKING_DIRECTORY ${CC_CONTRIB_BUILD_PATH})
            endforeach()
            # Build fat contrib: merge all .a files
            set(FAT_CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/apple-darwin${CMAKE_SYSTEM_VERSION})
            execute_process(COMMAND rm -rf ${FAT_CONTRIB_PATH})
            list(GET CMAKE_OSX_ARCHITECTURES 0 ARCH_FIRST)
            set(CONTRIB_PATH_FIRST ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${ARCH_FIRST}-apple-darwin${CMAKE_SYSTEM_VERSION})
            string(REPLACE "arm64" "aarch64" ARCH_FIRST_LIB ${ARCH_FIRST})
            set(TARGET_FIRST_LIB ${ARCH_FIRST_LIB}-apple-darwin${CMAKE_SYSTEM_VERSION})
            execute_process(COMMAND cp -r ${CONTRIB_PATH_FIRST} ${FAT_CONTRIB_PATH})
            file(GLOB_RECURSE LIB_FILES ${FAT_CONTRIB_PATH}/lib/*.a)
            foreach(LIB_FILE_PATH ${LIB_FILES})
                get_filename_component(LIB_FILE ${LIB_FILE_PATH} NAME)
                get_filename_component(LIB_FILE_NAME ${LIB_FILE_PATH} NAME_WLE)
                set(LIB_FILES_TO_MERGE "-create")
                foreach(ARCH ${CMAKE_OSX_ARCHITECTURES})
                    string(REPLACE "arm64" "aarch64" ARCH_LIB ${ARCH})
                    set(CC_TARGET ${ARCH}-apple-darwin${CMAKE_SYSTEM_VERSION})
                    set(CC_CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${CC_TARGET})
                    string(REPLACE ${TARGET_FIRST_LIB} ${ARCH_LIB}-apple-darwin${CMAKE_SYSTEM_VERSION} CC_LIB_FILE_NAME ${LIB_FILE})
                    set(CC_LIB_FILE_PATH "${CC_CONTRIB_PATH}/lib/${CC_LIB_FILE_NAME}")
                    if(NOT EXISTS ${CC_LIB_FILE_PATH})
                        message(FATAL_ERROR "Required library file not found: ${CC_LIB_FILE_PATH}")
                    endif()
                    list(APPEND LIB_FILES_TO_MERGE ${CC_LIB_FILE_PATH})
                endforeach()
                list(APPEND LIB_FILES_TO_MERGE "-output" "${FAT_CONTRIB_PATH}/lib/${LIB_FILE}")
                execute_process(COMMAND lipo ${LIB_FILES_TO_MERGE})
            endforeach()
            # replace all path references in pc and cmake files
            file(GLOB_RECURSE PC_FILES ${FAT_CONTRIB_PATH}/lib/pkgconfig/*.pc)
            file(GLOB_RECURSE CMAKE_FILES ${FAT_CONTRIB_PATH}/lib/cmake/*.cmake)
            list(APPEND ALL_FILES ${PC_FILES} ${CMAKE_FILES})
            foreach(FILE_PATH ${ALL_FILES})
                file(READ ${FILE_PATH} PC_FILE_CONTENT)
                string(REPLACE ${CONTRIB_PATH_FIRST} ${FAT_CONTRIB_PATH} PC_FILE_CONTENT ${PC_FILE_CONTENT})
                file(WRITE ${FILE_PATH} ${PC_FILE_CONTENT})
            endforeach()
            set(CONTRIB_PATH ${FAT_CONTRIB_PATH})
        else()
            message(STATUS "Building contrib for ${TARGET}")
            set(BOOTSTRAP_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/contrib/bootstrap --host=${TARGET})
            if (IGNORE_SYSTEM_LIBS)
                list(APPEND BOOTSTRAP_COMMAND --ignore-system-libs)
            endif()
            execute_process(
                COMMAND ${BOOTSTRAP_COMMAND}
                WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
            execute_process(COMMAND make list
                WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
            execute_process(COMMAND make ${CONTRIB_BUILD_FLAGS}
                WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
        endif()
        file(LOCK ${CONTRIB_BUILD_PATH} DIRECTORY RELEASE)
    else()
        set(SCRIPTS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/extras/scripts)
        execute_process(
            COMMAND python ${SCRIPTS_DIR}/winmake.py
            WORKING_DIRECTORY ${SCRIPTS_DIR}
            RESULT_VARIABLE BUILD_RESULT
        )
        if (BUILD_RESULT)
            message(FATAL_ERROR "Contrib build failed.")
        else()
            message(STATUS "Contrib build successful.")
        endif()
    endif()
endif()

################################################################################
# Check dependencies
################################################################################

if(NOT MSVC)
    include(FindPkgConfig)
    if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
        pkg_search_module (udev REQUIRED IMPORTED_TARGET libudev)
        pkg_search_module (pulseaudio IMPORTED_TARGET libpulse)
        pkg_search_module (alsa IMPORTED_TARGET alsa)
        pkg_search_module (jack IMPORTED_TARGET libjack)

        # Make sure at least one audio backend is available
        if(NOT pulseaudio_FOUND AND NOT alsa_FOUND AND NOT jack_FOUND)
            message(FATAL_ERROR "No audio library found. Please install PulseAudio, ALSA or JACK.")
        endif()
    endif()
endif()

################################################################################
# Source groups
################################################################################

# compat, src source group
if(MSVC)
    add_subdirectory("compat")
endif()

add_subdirectory("src")
source_group("Source Files" FILES ${Source_Files})
source_group("Source Files\\client" FILES ${Source_Files__client})
source_group("Source Files\\config" FILES ${Source_Files__config})
source_group("Source Files\\connectivity" FILES ${Source_Files__connectivity})
source_group("Source Files\\connectivity\\security" FILES ${Source_Files__security})
source_group("Source Files\\connectivity\\sip" FILES ${Source_Files__sip})

=== extras/packaging/gnu-linux/Makefile ===
# -*- mode: makefile; -*-
# Copyright (C) 2016-2025 Savoir-faire Linux Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
.DEFAULT_GOAL := package-all

# Default caching directory
export TARBALLS ?= /var/cache/jami

##############################
## Version number variables ##
##############################
TARBALL_VERSION := $(shell cat $(CURDIR)/.tarball-version 2> /dev/null)

ifeq ($(TARBALL_VERSION),)
RELEASE_VERSION := $(shell ./extras/packaging/gnu-linux/scripts/release-version.sh)
else
$(warning Using version from the .tarball-version file: $(TARBALL_VERSION))
RELEASE_VERSION := $(TARBALL_VERSION)
endif
RELEASE_DIRNAME := jami-$(RELEASE_VERSION)
RELEASE_TARBALL_FILENAME := $(RELEASE_DIRNAME).tar.gz

# Export for consumption in child processes.
export RELEASE_VERSION
export RELEASE_DIRNAME
export RELEASE_TARBALL_FILENAME

# Debian versions
DEBIAN_VERSION := $(RELEASE_VERSION)~dfsg1-1
DEBIAN_DSC_FILENAME := jami_$(DEBIAN_VERSION).dsc

# Qt versions
QT_MAJOR := 6
QT_MINOR := 8
QT_PATCH := 3
QT_TARBALL_CHECKSUM := cdd3a69967208276bb01af7ace7dba0ba53e679f886a4cbe624225c60fb73f2c
DEBIAN_QT_VERSION := $(QT_MAJOR).$(QT_MINOR).$(QT_PATCH)-0
DEBIAN_QT_DSC_FILENAME := libqt-jami_$(DEBIAN_QT_VERSION).dsc
QT_JAMI_PREFIX := /usr/lib/libqt-jami

#####################
## Other variables ##
#####################
TMPDIR := $(shell mktemp -d)
CURRENT_UID := $(shell id -u)
CURRENT_GID := $(shell id -g)

#############################
## Release tarball targets ##
#############################
.PHONY: release-tarball purge-release-tarballs portable-release-tarball
# See: https://reproducible-builds.org/docs/archives/
TAR_REPRODUCIBILITY_OPTIONS = \
	--format=gnu \
	--mtime=@1 \
	--owner=root:0 \
	--group=root:0

# This file can be used when not wanting to invoke the tarball
# producing machinery (which depends on the Git checkout), nor its
# prerequisites.  It is used to set the TARBALL_VERSION Make variable.
.tarball-version:
	echo $(RELEASE_VERSION) > $@

purge-release-tarballs:
	rm -f jami-*.tar.* tarballs.manifest

release-tarball:
	$(MAKE) -f extras/packaging/gnu-linux/Makefile "$(RELEASE_TARBALL_FILENAME)"

# Predicate to check if the 'guix' command is available.
has-guix-p:
	command -v guix > /dev/null 2>&1 || \
	  (echo 'guix' is required to build the '$@' target && exit 1)

# The bundled tarballs included in the release tarball depend on what
# is available on the host.  To ensure it can be shared across all
# different GNU/Linux distributions, generate it in a minimal
# container.  Wget uses GnuTLS, which looks up its certs from
# /etc/ssl/certs.
guix-share-tarball-arg = $${TARBALLS:+"--share=$$TARBALLS"}
portable-release-tarball: has-guix-p
	guix shell --container --network \
          --preserve=TARBALLS $(guix-share-tarball-arg) \
          --symlink=/usr/bin/env=bin/env \
          --symlink=/etc/ssl/certs=etc/ssl/certs \
          --manifest=extras/packaging/gnu-linux/guix/minimal-manifest.scm \
          -- $(MAKE) -f extras/packaging/gnu-linux/Makefile release-tarball

daemon/contrib/native/Makefile:
	mkdir -p ./daemon/contrib/native && \
	cd daemon/contrib/native && \
	../bootstrap

# Fetch the required contrib sources and copy them to
# daemon/contrib/tarballs.  To use a custom tarballs cache directory,
# export the TARBALLS environment variable.
tarballs.manifest: daemon/contrib/native/Makefile
	cd daemon/contrib/native && \
	$(MAKE) list && \
	$(MAKE) fetch -j && \
	$(MAKE) --no-print-directory --silent list-tarballs > "$(CURDIR)/$@"

ifeq ($(TARBALL_VERSION),)
# Generate the release tarball.  To regenerate a fresh tarball
# manually clear the tarballs.manifest file.
$(RELEASE_TARBALL_FILENAME): tarballs.manifest
# Prepare the sources of the top repository and relevant submodules.
	rm -f "$@"
	mkdir $(TMPDIR)/$(RELEASE_DIRNAME)
	git archive HEAD | tar xf - -C $(TMPDIR)/$(RELEASE_DIRNAME)
	for m in \
	    ./daemon \
	    . \
	    ./3rdparty/SortFilterProxyModel \
	    ./3rdparty/md4c \
	    ./3rdparty/tidy-html5 \
	    ./3rdparty/zxing-cpp \
	    ./3rdparty/hunspell; do \
	  (cd "$$m" && git archive --prefix "$$m/" HEAD \
	    | tar xf - -C $(TMPDIR)/$(RELEASE_DIRNAME)); \
	done
# Create the base archive.
	tar -cf $(TMPDIR)/$(RELEASE_DIRNAME).tar $(TMPDIR)/$(RELEASE_DIRNAME) \
	  --transform "s,.*/$(RELEASE_DIRNAME),$(RELEASE_DIRNAME)," \
	  $(TAR_REPRODUCIBILITY_OPTIONS)
# Append the cached tarballs listed in the manifest.
	tar --append --file $(TMPDIR)/$(RELEASE_DIRNAME).tar \
	  --files-from $< \
	  --transform "s,^.*/,$(RELEASE_DIRNAME)/daemon/contrib/tarballs/," \
        $(TAR_REPRODUCIBILITY_OPTIONS)
# Compress the tarball and move it into place.
	gzip --no-name $(TMPDIR)/$(RELEASE_DIRNAME).tar
	mv $(TMPDIR)/$(RELEASE_DIRNAME).tar.gz "$@"
	rm -rf $(TMPDIR)
else
# If TARBALL_VERSION is defined, assume it's already been generated,
# without doing any checks, which would require Git.
$(RELEASE_TARBALL_FILENAME):
endif

#######################
## Packaging targets ##
#######################

#
# Traditionally built packages (in Docker containers).
#
DISTRIBUTIONS := \
	debian_11 \
	debian_12 \
	debian_testing \
	debian_unstable \
	ubuntu_22.04 \
	ubuntu_24.04 \
	ubuntu_25.04 \
	fedora_41 \
	fedora_42 \
	alma_9 \
	alma_10 \
	opensuse-leap_15.6 \
	snap

IS_SHELL_INTERACTIVE := $(shell [ -t 0 ] && echo yes)

# The following Make variable can be used to provide extra arguments
# used with the 'docker run' commands invoked to build the packages.
DOCKER_RUN_EXTRA_ARGS =

# This function is used to produce the rules of the packaging targets
# that rely on Docker.
# Arg1: The name-version string of the distribution (e.g., ubuntu-18.04).
# Arg2: Extra arguments to pass to 'docker build'.
# Arg3: Extra arguments to pass to 'docker run'.
define make-docker-package-target
$(1)-docker-image-name := jami-packaging-$(1)
$(1)-docker-image-file := .docker-image-$$($(1)-docker-image-name)
$(1)-docker-run-command := docker run \
  --rm --privileged --security-opt apparmor=docker-default \
  -e BUILD_VERSION=${BUILD_VERSION} \
  -e RELEASE_VERSION="$(RELEASE_VERSION)" \
  -e RELEASE_DIRNAME="$(RELEASE_DIRNAME)" \
  -e RELEASE_TARBALL_FILENAME="$(RELEASE_TARBALL_FILENAME)" \
  -e DEBIAN_VERSION="$(DEBIAN_VERSION)" \
  -e DEBIAN_QT_VERSION="$(DEBIAN_QT_VERSION)" \
  -e CURRENT_UID="$(CURRENT_UID)" \
  -e CURRENT_GID="$(CURRENT_GID)" \
  -e DISTRIBUTION="$(1)" \
  -e QT_JAMI_PREFIX="$(QT_JAMI_PREFIX)" \
  -e QT_MAJOR="$(QT_MAJOR)" \
  -e QT_MINOR="$(QT_MINOR)" \
  -e QT_PATCH="$(QT_PATCH)" \
  -e QT_TARBALL_CHECKSUM="$(QT_TARBALL_CHECKSUM)" \
  -e FORCE_REBUILD_QT="$(FORCE_REBUILD_QT)" \
  -e SNAP_PKG_NAME="$(or $(SNAP_PKG_NAME),jami)" \
  -e TARBALLS="$(TARBALLS)" \
  -v '$(TARBALLS)':'$(TARBALLS)' \
  -v '$(CURDIR)/$(RELEASE_TARBALL_FILENAME)':'/src/$(RELEASE_TARBALL_FILENAME)' \
  -v '$(CURDIR)/extras/packaging/gnu-linux/packages/$(1)':/opt/output \
  -t $(and $(IS_SHELL_INTERACTIVE),-i) \
  $(3) \
  "$$($(1)-docker-image-name)"

$$($(1)-docker-image-file): extras/packaging/gnu-linux/docker/Dockerfile_$(1)
	docker build \
	  -t $$($(1)-docker-image-name) \
	  -f extras/packaging/gnu-linux/docker/Dockerfile_$(1) $(2) $(CURDIR) && \
	touch "$$@"

extras/packaging/gnu-linux/packages/$(1)/.packages-built: $(RELEASE_TARBALL_FILENAME) $$($(1)-docker-image-file)
	mkdir -p "$$$$(dirname "$$@")" && \
	$$($(1)-docker-run-command) && \
	touch "$$@"

.PHONY: $(1)
$(1): extras/packaging/gnu-linux/packages/$(1)/.packages-built
PACKAGE-TARGETS += $(1)

.PHONY: $(1)-interactive
$(1)-interactive: $(RELEASE_TARBALL_FILENAME) $$($(1)-docker-image-file)
	$$($(1)-docker-run-command) bash

endef

$(foreach target,$(DISTRIBUTIONS),\
	$(eval $(call make-docker-package-target,$(target))))

#
# Guix-generated Debian packages (deb packs) targets.
#
SUPPORTED_GNU_ARCHS = x86_64
GUIX_PACK_FORMATS = deb rpm

# TODO: Add a postin script for the RPM pack.
# Arg1: the 'guix pack' format to use, e.g. 'deb' or 'rpm'.
define guix-pack-command
guix pack -C xz -f $(1) -m $(CURDIR)/extras/packaging/gnu-linux/guix/guix-pack-manifest.scm -v3 \
  -S /usr/bin/jami=bin/jami \
  -S /usr/share/applications/net.jami.Jami.desktop=share/applications/net.jami.Jami.desktop \
  -S /usr/share/icons/hicolor/scalable/apps/net.jami.Jami.svg=share/icons/hicolor/scalable/apps/net.jami.Jami.svg \
  -S /usr/share/icons/hicolor/48x48/apps/jami.png=share/icons/hicolor/48x48/apps/jami.png \
  -S /usr/share/metainfo/net.jami.Jami.metainfo.xml=share/metainfo/net.jami.Jami.metainfo.xml \
  -S /usr/share/swcatalog/xml/jami.xml=share/swcatalog/xml/jami.xml \
  $(and $(findstring deb,$(1)), \
    --postinst-file=$(CURDIR)/extras/packaging/gnu-linux/guix/guix-pack-deb.postinst)
endef

# Arg1: the 'guix pack' format to use, e.g. 'deb' or 'rpm'.
# Arg2: the GNU architecture type (e.g., x86_64, i686, powerpcle, etc.)
define define-guix-pack-rule
$(1)-file-name := extras/packaging/gnu-linux/packages/guix-$(1)-pack/jami-$(RELEASE_VERSION)-$(2).$(1)
PACKAGE-TARGETS += $(1)-pack-$(subst _,-,$(2))
.PHONY: $(1)-pack-$(subst _,-,$(2))
$(1)-pack-$(subst _,-,$(2)): $$($(1)-file-name)
$$($(1)-file-name): has-guix-p $(RELEASE_TARBALL_FILENAME)
	output=$$$$($(call guix-pack-command,$(1)) --system=$(2)-linux $$(GUIX_PACK_ARGS)) && \
	mkdir -p "$$$$(dirname "$$@")" && \
	cp --reflink=auto "$$$$output" "$$@" && \
	guix gc --delete "$$$$output"
	chmod +w "$$@"
endef

$(foreach format,$(GUIX_PACK_FORMATS),\
  $(foreach arch,$(SUPPORTED_GNU_ARCHS),\
    $(eval $(call define-guix-pack-rule,$(format),$(arch)))))

package-all: $(PACKAGE-TARGETS)

.PHONY: list-package-targets
list-package-targets:
	@$(foreach p,$(sort $(PACKAGE-TARGETS)),\
		echo $(p);)

###################
## Other targets ##
###################
.PHONY: docs

# Build the documentation
# Note that newly added RST files will likely not display on all documents'
# navigation bar unless the docs/build folder is manually deleted.
docs: env
	env/bin/sphinx-build -b html docs/source docs/build/html
	env/bin/sphinx-build -b texinfo docs/source docs/build/texinfo

env:
	virtualenv env
	env/bin/pip install Sphinx==1.4.1 sphinx-rtd-theme==0.1.9

.PHONY: clean
clean:
	rm -rf env
	rm -rf docs/build
	rm -f jami-*.tar.gz
	rm -rf extras/packaging/gnu-linux/packages
	rm -f .docker-image-*
	rm -rf daemon/contrib/tarballs/*

=== extras/packaging/gnu-linux/rules/debian/control ===
Source: jami
Section: comm
Priority: optional
Maintainer: The Jami project <jami@gnu.org>
Build-Depends: debhelper (>= 9),
               autoconf,
               automake,
               libtool,
               autotools-dev,
# qt client
               libqt-jami,
               python3,
               libnm-dev,
               libnotify-dev,
               libqrencode-dev,
               libayatana-appindicator3-dev | libappindicator3-dev,
# daemon
               libdbus-1-dev,
               libsystemd-dev,
               libupnp-dev,
               libgnutls28-dev,
               libpulse-dev,
               libasound2-dev,
               libexpat1-dev,
               libpcre3-dev | libpcre2-dev,
               libyaml-cpp-dev,
               libboost-dev,
               libxext-dev,
               libxfixes-dev,
               libspeex-dev,
               libspeexdsp-dev,
               uuid-dev,
               libavcodec-dev | libavcodec-extra-dev,
               libavutil-dev,
               libavformat-dev,
               libswscale-dev,
               libavdevice-dev,
               libopus-dev,
               libudev-dev,
               libgsm1-dev,
               libjsoncpp-dev,
               libnatpmp-dev,
               libva-dev,
               libcrypto++-dev,
               libvdpau-dev,
               libssl-dev,
               libargon2-dev | libargon2-0-dev,
# TODO: remove libpipewire-0.2-dev once we stop supporting Ubuntu 20.04
               libpipewire-0.3-dev | libpipewire-0.2-dev,
# other
               nasm,
               yasm,
Standards-Version: 4.1.5
Homepage: https://jami.net
Vcs-Git: https://git.jami.net/savoirfairelinux/jami-client-qt.git
Vcs-Browser: https://git.jami.net/savoirfairelinux/jami-client-qt

# The jami-all package is used as the "one-click install" package
# offered on the Jami website.  The following relationships ensure
# that installing the jami-all package replaces version of the other
# individual Jami packages.  This is so that users can fix any
# installation problem on their side by simply reinstalling as per the
# website instructions.
#
Package: jami-all
Architecture: any
Depends: gnupg,
         ${shlibs:Depends},
         ${misc:Depends}
Replaces: jami,
          jami-libclient,
          jami-daemon,
          libqt-jami (>= 6.6.1),
Conflicts: jami,
           jami-libclient,
           jami-libclient-gnome,
           jami-daemon,
           jami-gnome,
           libqt-jami
Description: One-click install package for Jami
 This package only exists to provide an easy installation user experience.
 To install the default client, install the 'jami' package.

Package: jami
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         jami-daemon (=${binary:Version}),
         libqt-jami (>= 6.6.1)
Provides: jami-qt
Replaces: jami-all,
          jami-libclient (<= 20220516.0214.9b42ad3~dfsg1-1)
Breaks: jami-libclient (<= 20220516.0214.9b42ad3~dfsg1-1)
Conflicts: jami-all
Description: Secure and distributed voice, video and chat platform - desktop client
 Jami (jami.net) is a secure and distributed voice, video and chat communication
 platform that requires no centralized server and leaves the power of privacy
 in the hands of the user.
 .
 This package contains the jami-qt desktop client.

# Made into a transitional package on 2022-06-21, after libjamiclient
# was merged into src/libclient under jami-client-qt.git, to provide
# an upgrade path to existing users.  Feel free to remove this package
# later into the future, some time after 2023-06-21 perhaps.
Package: jami-libclient
Architecture: any
Description: transitional package for jami
 This is a transitional package. Jami libclient has been merged into
 the jami-qt client code-base, and this package can be safely removed.

Package: jami-daemon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Secure and distributed voice, video and chat platform - daemon
 Jami (jami.net) is a secure and distributed voice, video and chat communication
 platform that requires no centralized server and leaves the power of privacy
 in the hands of the user.
 .
 This package contains the Jami daemon: jamid.
